//Federico Ravenna and Carl Walsh
//"Worker heterogeneity, selection, and employment dynamics in a pandemic"
//Journal of Money, Credit and Banking
//First draft: April 2020
// Current draft: August 2021

// SEE README JMCB RAVENNA WALSH 2021.DOC


var jd jc jturn wturn kwl kfh kfl kjobw kjobf holav s lambda hobar h v gamat xit sh sl nh nl n rhot uh ul u th kw kf rhon q ctot y rn c abar mu ql wul ho surph qh wuh x Pi pnum pdenom f z d m rntrue;

//varexo e1 e2 e3;
varexo e1 e2 e3;

parameters holav_ss n_ss rhox sl_ss sh_ss gamabar s_ss gamat_ss nh_ss nl_ss xit_ss;
parameters kw_ss h_ss rhon_ss rhot_ss mubar sigm disc phi chi_ho thetap theta;
parameters alpha kf_ss Pi_ss ho_ss f_ss z_ss KK mu_ss a_ss eta v_ss HH GG;
parameters ul_ss uh_ss unempl_duration_h_ss unempl_duration_l_ss ratio_duration_ss;
parameters psi theta_ss c_ss y_ss q_ss lambda_ss ell ctot_ss wuh_ss surph_ss qh_ss;
parameters zh_ss wuhome_h hobar_ss wul_ss ql_ss x_ss kappa rn_ss mc_ss;
parameters quad, chi, omegap, omegay, rhoz, rhod, rhom, u_ss;
parameters jd_ss jc_ss jturn_ss wturn_ss kwl_ss kfh_ss kfl_ss kjobw_ss kjobf_ss zl_ss;

carl202parameters

quad = quad_;
chi = chi_;
omegap=omegap_;
omegay=omegay_;
rhoz = rhoz_;
rhod = rhod_;
rhom = rhom_;             

holav_ss = holav_ss_; 
n_ss = n_ss_;
rhox=rhox_;
sl_ss=sl_ss_;
 sh_ss=sh_ss_;
gamabar=gamabar_; 
s_ss=s_ss_;
 gamat_ss= gamat_ss_;
 nh_ss= nh_ss_;
 nl_ss= nl_ss_;
 xit_ss= xit_ss_;
kw_ss=kw_ss_;
 h_ss= h_ss_;
 rhon_ss= rhon_ss_;
 rhot_ss= rhot_ss_;
 mubar= mubar_;
 sigm= sigm_;
 disc= disc_;
 phi= phi_;
 chi_ho= chi_ho_;
 thetap= thetap_;
 theta= theta_;
alpha=alpha_;
 kf_ss= kf_ss_;
 Pi_ss= Pi_ss_;
 ho_ss= ho_ss_;
 f_ss= f_ss_;
 z_ss= z_ss_;
 KK= KK_;
 mu_ss=mu_ss_;
 a_ss= a_ss_;
 eta= eta_;
 v_ss= v_ss_;
 HH= HH_;
 GG=GG_;
ul_ss=ul_ss_;
 uh_ss= uh_ss_;
 unempl_duration_h_ss= unempl_duration_h_ss_;
 unempl_duration_l_ss= unempl_duration_l_ss_;
 ratio_duration_ss= ratio_duration_ss_;
psi=psi_;
 theta_ss= theta_ss_;
 c_ss= c_ss_;
 y_ss= y_ss_;
 q_ss= q_ss_;
 lambda_ss= lambda_ss_;
 ell= ell_;
 ctot_ss= ctot_ss_;
 wuh_ss= wuh_ss_;
 surph_ss= surph_ss_;
 qh_ss= qh_ss_;
zh_ss=zh_ss_;
 wuhome_h= wuhome_h_;
 hobar_ss= hobar_ss_;
 wul_ss= wul_ss_;
 ql_ss= ql_ss_;
 x_ss= x_ss_;
 kappa= kappa_;
 rn_ss= rn_ss_;
 mc_ss= mc_ss_;
 u_ss= u_ss_;
jd_ss=jd_ss_;
 jc_ss= jc_ss_;
 jturn_ss= jturn_ss_;
 wturn_ss= wturn_ss_;
 kwl_ss= kwl_ss_;
 kfh_ss= kfh_ss_;
 kfl_ss= kfl_ss_;
 kjobw_ss= kjobw_ss_;
 kjobf_ss= kjobf_ss_;
 holav_ss= holav_ss_;
 zl_ss=zl_ss_;

model;


//With composition effect
exp(gamat) = exp(sl-s);
exp(xit) = exp(nl-n);
exp(sh) = (1-gamabar)-(1-rhox*exp(z))*exp(nh(-1));
exp(s) = exp(sh)+exp(sl);  //can be replaced by following:
//exp(sl)=gamabar-(1-rhox*exp(z))*exp(xit(-1)+n(-1));
exp(n) = exp(nh)+exp(nl);

exp(s) = 1-(1-rhox*exp(z))*exp(n(-1));
exp(xit) = (1-exp(rhon))*(exp(xit(-1))*(1-rhox*exp(z))*exp(n(-1))+exp(gamat+kw+s))/exp(n);
exp(h) = (1-exp(gamat)*exp(rhon))*exp(kw)*exp(s);
exp(n) = (1-exp(xit(-1)+rhon))*(1-rhox*exp(z))*exp(n(-1))+exp(h);
exp(rhot) = rhox*exp(z)+(1-rhox*exp(z))*exp(xit(-1)+rhon);
//exp(rhot) = rhox*exp(z);
exp(uh) = 1-exp(nh)/(1-gamabar);
exp(ul) = 1-exp(nl)/(gamabar);
exp(u) = 1-exp(n);
exp(th) = exp(v-s);
exp(kw)=exp(0*m)*psi*exp((1-alpha)*th);     // use exp(m) as shock to matching function
exp(kf) = exp(0*m)*psi*exp((-alpha)*th);    // use exp(m) as shock to matching function
exp(rhon) = exp(abar);
exp(q) = exp(y+f);

// in the following, equations are modified to allow fo distributional productivity shock
//exp(q)= exp(n+z)*(exp(xit)*((exp(lambda+z)/(exp(mu)*ell))^(1/chi_ho))*(1-(exp(abar))^(2+1/chi_ho))/((1-exp(abar))*(2+1/chi_ho))+(1-exp(xit))*zh_ss*exp(ho));  
exp(q)= exp(n+0*z)*(zl_ss*exp(xit)*((exp(lambda+0*z)*zl_ss/(exp(mu)*ell))^(1/chi_ho))*(1-(exp(abar))^(2+1/chi_ho))/((1-exp(abar))*(2+1/chi_ho))+(1-exp(xit))*zh_ss*exp(0*d)*exp(ho));  

exp(ctot) = exp(c)+(gamabar-exp(nl))*wuhome_h+(1-gamabar-exp(nh))*wuhome_h;
//exp(y) = exp(c)+kappa*exp(v);
//QUADRATIC VACANCY COST
exp(y) = exp(c)+kappa*(exp(v))^quad;
exp(lambda) = disc*exp(0*m)*exp(rntrue)*exp(lambda(+1)-Pi(+1));     //use exp(m) to temporarily lower discount rate 
// ERA demand below // 
exp(lambda) = exp(1*d)*(exp(ctot)-phi*exp(ctot(-1)))^(-sigm)-disc*exp(1*d(+1))*phi*exp(0*m(+1))*(exp(ctot(+1))-phi*exp(ctot))^(-sigm);   // use exp(d) as shock to preferences
//// ERA sep rate /// exp(lambda) = exp(0*d)*(exp(ctot)-phi*exp(ctot(-1)))^(-sigm)-disc*exp(1*d(+1))*phi*exp(1*m(+1))*(exp(ctot(+1))-phi*exp(ctot))^(-sigm);   // use exp(d) as shock to preferences
exp(abar+0*z+lambda-mu)*zl_ss = ell*exp(hobar*chi_ho);    

//BELOW: ORIGINAL MARKET
//exp(abar) = (exp(mu)/(exp(0*z+hobar)*zl_ss))*(exp(wul)-exp(ql)+ell/(exp(lambda)*(1+chi_ho))*(exp(abar+lambda+0*z)*zl_ss/(ell*exp(mu)))^((1+chi_ho)/chi_ho)); 
//BELOW: PLANNER SETUP, MARKET EQUILIBRIUM
exp(abar) = (exp(mu)/(exp(0*z+hobar)*zl_ss))*(ell/(exp(lambda)*(1+chi_ho))*(exp(abar+lambda+0*z)*zl_ss/(ell*exp(mu)))^((1+chi_ho)/chi_ho)-(disc*exp(1*m)*(exp(lambda(+1)-lambda))*(1-rhox*exp(z(+1)))*(1-exp(rhon(+1)))*exp(x(+1))-wuhome_h-disc*exp(1*m)*(exp(lambda(+1)-lambda))*(1-rhox*exp(z(+1)))*(exp(kw(+1))*eta*(1-exp(rhon(+1)))*exp(x(+1))))); // TO USE FOR PLANNER

//BELOW: ORIGINAL MARKET
//exp(x) = zl_ss*exp(0*z-mu)*((exp(lambda+0*z)*zl_ss/(exp(mu)*ell))^(1/chi_ho))*(1-exp(abar*(2+1/chi_ho)))/((1-exp(abar))*(2+1/chi_ho))-1/exp(lambda)*ell/(1+chi_ho)*((exp(lambda+0*z)*zl_ss/(exp(mu)*ell))^((1+chi_ho)/chi_ho))*(1-exp(abar*(1+(1+chi_ho)/chi_ho)))/((1-exp(abar))*(1+(1+chi_ho)/chi_ho))-exp(wul)+exp(ql);  
//BELOW: PLANNER SETUP, MARKET EQUILIBRIUM
exp(x) = zl_ss*exp(0*z-mu)*((exp(lambda+0*z)*zl_ss/(exp(mu)*ell))^(1/chi_ho))*(1-exp(abar*(2+1/chi_ho)))/((1-exp(abar))*(2+1/chi_ho))-1/exp(lambda)*ell/(1+chi_ho)*((exp(lambda+0*z)*zl_ss/(exp(mu)*ell))^((1+chi_ho)/chi_ho))*(1-exp(abar*(1+(1+chi_ho)/chi_ho)))/((1-exp(abar))*(1+(1+chi_ho)/chi_ho))+ disc*exp(1*m)*(exp(lambda(+1)-lambda))*(1-rhox*exp(z(+1)))*(1-exp(rhon(+1)))*exp(x(+1))-wuhome_h-disc*exp(1*m)*(exp(lambda(+1)-lambda))*(1-rhox*exp(z(+1)))*(exp(kw(+1))*eta*(1-exp(rhon(+1)))*exp(x(+1)));  // TO USE FOR PLANNER
//BELOW: PLANNER EQUILIBRIUM
// exp(x) = zl_ss*exp(0*z-mu)*((exp(lambda+0*z)*zl_ss/(exp(mu)*ell))^(1/chi_ho))*(1-exp(abar*(2+1/chi_ho)))/((1-exp(abar))*(2+1/chi_ho))-1/exp(lambda)*ell/(1+chi_ho)*((exp(lambda+0*z)*zl_ss/(exp(mu)*ell))^((1+chi_ho)/chi_ho))*(1-exp(abar*(1+(1+chi_ho)/chi_ho)))/((1-exp(abar))*(1+(1+chi_ho)/chi_ho))+ disc*exp(1*m)*(exp(lambda(+1)-lambda))*(1-rhox*exp(z(+1)))*(1-exp(rhon(+1)))*exp(x(+1))-wuhome_h-disc*exp(1*m)*(exp(lambda(+1)-lambda))*(1-rhox*exp(z(+1)))*(exp(kw(+1))*eta*(1-exp(rhon(+1)))*exp(x(+1)))+disc*exp(1*m)*(exp(lambda(+1)-lambda))*(1-rhox*exp(z(+1)))*exp(kw(+1))*(1-eta)*(1-exp(gamat(+1)))*(exp(surph(+1))-(1-exp(rhon(+1)))*exp(x(+1)));  // TO USE FOR PLANNER

exp(ql) = disc*exp(1*m)*(exp(lambda(+1)-lambda))*((1-rhox*exp(z(+1)))*(1-exp(rhon(+1)))*exp(x(+1))+exp(wul(+1)));   //use exp(m) to temporarily lower discount rate 
//BELOW: ORIGINAL BEFORE CORRECTION
//exp(wul) = wuhome_h+disc*exp(1*m)*(exp(lambda(+1)-lambda))*(exp(kw(+1))*eta*(1-exp(rhon(+1)))*exp(x(+1))+exp(wul(+1)));  //use exp(m) to temporarily lower discount rate 
//BELOW: MODIFIED TO MAKE CONSISTENT WITH APPENDIX KIEV
exp(wul) = wuhome_h+disc*exp(1*m)*(exp(lambda(+1)-lambda))*((1-rhox*exp(z(+1)))*exp(kw(+1))*eta*(1-exp(rhon(+1)))*exp(x(+1))+exp(wul(+1)));  //use exp(m) to temporarily lower discount rate 

//exp(ho) = (exp(z)*zh_ss*exp(lambda)/(ell*exp(mu)))^(1/chi_ho);
exp(ho) = (exp(0*z)*exp(0*d)*zh_ss*exp(lambda)/(ell*exp(mu)))^(1/chi_ho);   // use exp(d) as skill-biased tech shock

//exp(surph) = exp(z)*zh_ss*exp(ho-mu)-(ell/(1+chi_ho))*(exp(ho*(1+chi_ho)))/exp(lambda)+exp(qh)-exp(wuh);
//BELOW: ORIGINAL MARKET
//exp(surph) = exp(0*z)*exp(0*d)*zh_ss*exp(ho-mu)-(ell/(1+chi_ho))*(exp(ho*(1+chi_ho)))/exp(lambda)+exp(qh)-exp(wuh); //ORIGINAL use exp(d) as skill-biased tech shock
//BELOW: PLANNER SETUP, MARKET EQUILIBRIUM
exp(surph) = exp(0*z)*exp(0*d)*zh_ss*exp(ho-mu)-(ell/(1+chi_ho))*(exp(ho*(1+chi_ho)))/exp(lambda)+disc*exp(1*m)*(exp(lambda(+1)-lambda))*((1-rhox*exp(z(+1)))*exp(surph(+1)))-wuhome_h-disc*exp(1*m)*(exp(lambda(+1)-lambda))*(1-rhox*exp(z(+1)))*(exp(kw(+1))*eta*exp(surph(+1))); // use exp(d) as skill-biased tech shock // TO USE FOR PLANNER
//BELOW: PLANNER EQUILIBRIUM
//exp(surph) = exp(0*z)*exp(0*d)*zh_ss*exp(ho-mu)-(ell/(1+chi_ho))*(exp(ho*(1+chi_ho)))/exp(lambda)+disc*exp(1*m)*(exp(lambda(+1)-lambda))*((1-rhox*exp(z(+1)))*exp(surph(+1)))-wuhome_h-disc*exp(1*m)*(exp(lambda(+1)-lambda))*(1-rhox*exp(z(+1)))*(exp(kw(+1))*eta*exp(surph(+1)))-disc*exp(1*m)*(exp(lambda(+1)-lambda))*(1-rhox*exp(z(+1)))*exp(kw(+1))*(1-eta)*exp(gamat(+1))*(exp(surph(+1))-(1-exp(rhon(+1)))*exp(x(+1)));  // TO USE FOR PLANNER


exp(qh) = disc*exp(1*m)*(exp(lambda(+1)-lambda))*((1-rhox*exp(z(+1)))*exp(surph(+1))+exp(wuh(+1)));  //use exp(m) to temporarily lower discount rate 
//BELOW: ORIGINAL BEFORE CORRECTION
//exp(wuh) = wuhome_h+disc*exp(1*m)*(exp(lambda(+1)-lambda))*(exp(kw(+1))*eta*exp(surph(+1))+exp(wuh(+1))); //use exp(m) to temporarily lower discount rate 
//BELOW: MODIFIED TO MAKE CONSISTENT WITH APPENDIX KIEV
exp(wuh) = wuhome_h+disc*exp(1*m)*(exp(lambda(+1)-lambda))*((1-rhox*exp(z(+1)))*exp(kw(+1))*eta*exp(surph(+1))+exp(wuh(+1))); //use exp(m) to temporarily lower discount rate 

//QUADRATIC VACANCY COST
//exp(x) = (1/(exp(gamat)*(1-exp(rhon))))*(kappa/(exp(kf)*(1-eta))-(1-exp(gamat))*exp(surph));  // Paper definition
exp(x) = (1/(exp(gamat)*(1-exp(rhon))))*((kappa*quad*(exp(v))^(quad-1))/(exp(kf)*(1-eta))-(1-exp(gamat))*exp(surph));  // Paper definition

exp((1-theta)*Pi) = thetap+(1-thetap)*exp((1-theta)*(pnum-pdenom+Pi)); // STANDARD
//exp((1-theta)*Pi) = thetap*exp(1*(1-theta)*Pi(-1))+(1-thetap)*exp((1-theta)*(pnum-pdenom+Pi)); // CEE
//exp((1-theta)*Pi) = thetap+(1-thetap)*(1-0.25)*exp((1-theta)*(pnum-pdenom+Pi))+(1-thetap)*0.25*exp((1-theta)*Pi(-1)); // HYBRID GG

//HYBRID AND CALVO
exp(pnum) = mubar*exp(lambda+y-mu) + thetap*disc*exp(1*m)*exp(pnum(+1)+theta*Pi(+1));   //use exp(m) to temporarily lower discount rate 
exp(pdenom) = exp(lambda+y) + thetap*disc*exp(1*m)*exp(pdenom(+1)+(theta-1)*Pi(+1));  //use exp(m) to temporarily lower discount rate 
//CEE
//exp(pnum) = mubar*exp(lambda+y-mu) + thetap*disc*exp(1*m)*exp(pnum(+1)+(1+theta)*Pi(+1)-1*theta*Pi);   //CEE use exp(m) to temporarily lower discount rate 
//exp(pdenom) = exp(lambda+y) + thetap*disc*exp(1*m)*exp(pdenom(+1)+theta*Pi(+1)+1*(1-theta)*Pi);  //CEE use exp(m) to temporarily lower discount rate 
//EXPECTATION t-1 CEE
//exp(pnum) = mubar*exp(EXPECTATION(-1)(lambda)+EXPECTATION(-1)(y)-EXPECTATION(-1)(mu)) + thetap*disc*exp(1*m)*exp(pnum(+1)+(1+theta)*EXPECTATION(-1)(Pi(+1))-1*theta*EXPECTATION(-1)(Pi));   //CEE use exp(m) to temporarily lower discount rate 
//exp(pdenom) = exp(EXPECTATION(-1)(lambda)+EXPECTATION(-1)(y)) + thetap*disc*exp(1*m)*exp(pdenom(+1)+theta*EXPECTATION(-1)(Pi(+1))+1*(1-theta)*EXPECTATION(-1)(Pi));  //CEE use exp(m) to temporarily lower discount rate 
////EXACT SBORDONE FORMULATION CEE
////exp(pnum) = mubar*exp(-mu) + thetap*disc*exp(1*m)*exp((y(+1)-y)+(lambda(+1)-lambda)+pnum(+1)+(theta)*Pi(+1)-1*theta*Pi);   //CEE use exp(m) to temporarily lower discount rate 
////exp(pdenom) = 1 + thetap*disc*exp(1*m)*exp((y(+1)-y)+(lambda(+1)-lambda)+pdenom(+1)+(theta-1)*Pi(+1)+1*(1-theta)*Pi);  //CEE use exp(m) to temporarily lower discount rate 


exp(f) = thetap*exp(theta*Pi+f(-1)) + (1-thetap)*exp(-theta*(pnum-pdenom));
exp(rn) = exp(chi*rn(-1) + (1-chi)*(log(rn_ss)+omegay*(y-log(y_ss))+omegap*(Pi-log(Pi_ss))) - 0*m);     // use exp(m) as shock to monetary policy
//exp(rn) = exp(chi*rn(-1) + (1-chi)*(log(rn_ss)+omegay*(y-y(-1))+omegap*(Pi-log(Pi_ss))) - 0*m);     // use exp(m) as shock to monetary policy
//exp(rn) = exp(chi*rn(-1) + (1-chi)*(log(rn_ss)-omegay*(u-log(u_ss))+omegap*(Pi-log(Pi_ss))) +0*m);     // use exp(m) as shock to monetary policy
//exp(Pi)=Pi_ss;  //POLICY RULE
exp(holav)= (exp(lambda+0*z)*zl_ss/(exp(mu)*ell))^(1/chi_ho)*(1-(exp(abar))^(1+1/chi_ho))/((1-(exp(abar)))*(1+1/chi_ho));
exp(jd) = (rhox*exp(z)+exp(rhon)*(1-rhox*exp(z))*exp(xit)-rhox*exp(z)*(exp(h-v)))*exp(n);
exp(jc) = exp(kf+h)/exp(kw+s)*(exp(v)-rhox*exp(z)*exp(n));
exp(jturn) = exp(jc)+exp(jd);
exp(wturn) = exp(rhot+n(-1))+exp(h);
exp(kwl) = exp(kw)*(1-exp(abar));
exp(kfh) = exp(kf)*(1-exp(gamat));
exp(kfl) = exp(kf+gamat)*(1-exp(abar));
exp(kjobw) = exp(gamat+kwl)+(1-exp(gamat))*exp(kw);
exp(kjobf) = exp(kfl)+(1-exp(gamat))*exp(kf);
exp(rntrue)=exp(rn)+e3;//(-(1/disc - 1));

//0 = c - ell*exp(n)*(exp(ho)^(1+gama))/(1+gama) - ut;         // LOG UTILITY
//welf = ut + disc*welf(+1);        // WELFARE IS IN LEVELS

//z = rhoz*z(-1) -0*e1;  //tech shock
z = rhoz*z(-1) + e1;  //tech shock  // DYNARE 461
//d = rhod*d(-1) + e2;  //shock to zh_ss only
//d = rhod*d(-1) + 0.75*e1;  // DRAFT 15 dec 2011 - JMCB - use VARE1 = 8; shock to zh_ss occuring contemporaneously, and with opposite sign, to 'z' shock
//d = rhod*d(-1) + 0.8*e1;  // DRAFT OCT 15 2011 use VARE1 = 6; shock to zh_ss occuring contemporaneously, and with opposite sign, to 'z' shock
//m = rhom*m(-1) -2*e3;  //TFP shock to matching function OR mopol shock OR demand shock
//m = rhom*m(-1) + 2*e1;  // Use for TFP shock to matching function together with skill-biased shock
//ERA
m = rhom*m(-1) +0*0.37*e1; // shock to discount factor
//ERA rhox
//m = rhom*m(-1) -1.5*e1;
//d = rhod*d(-1) - 1*e1;    //shock to preferences
d = rhod*d(-1) - e2;    //shock to preferences
end;

shocks;
var e1 = 0;//1.01;
var e2 = 0;//30;
var e3 = 0;
//var e1 = 0;     // for d : 0.08^2
//var e2 = 0.007;     // for a : 0.0035^2
//var e3 = 0;     // for m : 0.003^2
end;

initval;
jd = log(jd_ss);
jc =log(jc_ss);
jturn =log(jturn_ss);
wturn =log(wturn_ss);
kwl = log(kwl_ss);
kfh = log(kfh_ss);
kfl = log(kfl_ss);
kjobw =log(kjobw_ss);
kjobf = log(kjobf_ss);
holav = log(holav_ss);
z = 0;
d = 0;
m = 0;
n = log(n_ss);
q = log(q_ss);
v = log(v_ss);
th = log(theta_ss);
rn = log(rn_ss);
rntrue = log(rn_ss);
mu = log(mu_ss);
y = log(y_ss);
c = log(c_ss);
lambda = log(lambda_ss);
Pi = log(Pi_ss);
pnum = log(mubar)-log(mu_ss)+lambda+y - log(1-thetap*disc*Pi_ss^theta);
pdenom = lambda+y - log(1-thetap*disc*Pi_ss^(theta-1));
f=log(f_ss);
ho = log(ho_ss);
hobar = log(hobar_ss);
h = log(h_ss); 
gamat = log(gamat_ss);
xit = log(xit_ss);
sh = log(sh_ss); 
sl = log(sl_ss); 
nh = log(nh_ss); 
nl = log(nl_ss);
rhot = log(rhot_ss); 
uh = log(uh_ss); 
ul = log(ul_ss); 
u = log(u_ss);
kw = log(kw_ss); 
kf = log(kf_ss); 
ctot = log(ctot_ss);
abar = log(a_ss); 
x = log(x_ss);
ql =log(ql_ss);
wul = log(wul_ss);
surph = log(surph_ss); 
qh = log(qh_ss); 
wuh =   log(wuh_ss);
rhon =  log(rhon_ss);
s = log(s_ss);

end;

steady(nocheck);
//steady(solve_algo=0);


tic
stoch_simul( nocorr, drop=0,order=1,irf=0);
//stoch_simul(simul,periods=2000,dr_algo=0,drop=0,nocorr,order=1,irf=0); //for simulations
toc

conditional_forecast_paths;
var rhot; //SHOCK: e1 (z)
//periods 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20;
//values 32.60911511	28.19121181	25.95605232	24.34762317	22.95390926	21.66458311	20.44857454	19.29558154	18.20077674	17.16083714	16.17292121	15.2344058	14.34281659	13.49580663	12.69114703	11.9267203	11.20051488	10.51061975	9.855219332	9.23258895;
//values 97.82734533	84.57363543	77.86815696	73.04286951	68.86172778	64.99374933	61.34572362	57.88674462	54.60233022	51.48251142	48.51876363	45.7032174	43.02844977	40.48741989	38.07344109	35.7801609	33.60154464	31.53185925	29.565658	27.69776685;
//values 64.99374933	90.99124906	100.090374	80.07229917	64.05783934	51.24627147	15.37388144	4.612164432	1.38364933	0.415094799	0.12452844	0.037358532	0.01120756	0.003362268	0.00100868	0.000302604	0	0	0	0;
periods 1 2 3 4 5 6 7 8 9 10;
////KIEV May 2020 below
//values 64.99374933	90.99124906	100.090374	50.15722089	27.87940144	16.92352895	11.07177596	7.719420446	5.681290434	4.378042193;
////JMCB Revision and corrected for ss JOLTS
/////////values 63.20126642	43.88526642	-6.013233576	-0.379733576	-0.601033576	-0.800203576	-0.979456576	-1.140784276	-1.285979206	-1.416654643;
// TRIAL values 65.794	96.478	50.4205	2.213	1.9917	1.79253	1.613277	1.4519493 1.30675437	1.176078933;
////JMCB Revision and corrected for ss CPS (rho = 0.695)
values 147.4072664	98.50726642	65.54866642	43.33457002	28.36226905	18.27093819	11.4693812	6.885131781	3.795347675	1.712833187;
//values 64.99374933	90.99124906	100.090374	79.5010192	63.8784047	51.89032113	42.59239295	35.30737567	29.54419537	24.94299262;
//periods 1;
//values 97.8;

//periods 1;
//values 400;
//var z; //SHOCK: e1
//periods 1 2 3 4 5 6 7 8 9 10;
//values 50 100 0 0 0 0 0 0 0 0;

//periods 1 2 3 4 5 6 7 8 9 10; //path corresponding to benchmark exercise with selection
// CORRECTED PAPER VALUES
//////////////values 26.62709835	38.89947797	45.14179224	24.15407715	13.42676229	8.206560678	5.765216494	4.68146302	4.248635628	4.122489033;
/////////PAPERvalues 23.2019671	34.06847219	39.42813954	21.64385993	12.32535854	7.624302814	5.310656726	4.198553509	3.68391577	3.464655381;
///////////values 57.63965906	81.86648602	91.72616628	48.65402841	28.02325907	17.70633623	12.32820664	9.402257408	7.740432993	6.756550388;
////JMCB Revision and corrected for ss JOLTS
//values 42.47206453	30.25290945	-13.96937291	-6.945570143	-6.294169219	-5.709557159	-5.151955979	-4.640736566	-4.177842558	-3.760404067;
////JMCB Revision and corrected for ss CPS (rho = 0.695)
/////////values 121.0287908	82.31041825	53.82965725	35.07707565	21.66317442	14.72310715	9.960483018	6.724663587	4.535879265	3.058254081;
////JMCB Revision and corrected for ss CPS USE FOR RHO = 0.95
//values 91.90771611	62.84688329	39.37264509	24.4077404	12.99896013	5.518166707	0.797808101	-2.092193288	-3.777196622	-4.676204306;
//RHO = 0.695 AND omega = 0.25
//values 123.7815777	85.09456662	56.61034661	37.75781822	24.57771183	17.04912146	11.71081413	8.014345133	5.471988682	3.729741073;



//periods 1;
//values 97;
//values 18.075; // USE FOR SINGLE SHOCK TO RHOX WITH SAME y AS BENCHMARK d SHOCK
//values 2.25;  // USE FOR SINGLE SHOCK TO RHOX WITH 1% increase
//values for 'n'
//values -0.4819,	-0.5754,	-0.5806,	-0.563,	-0.54,	-0.5166,	-0.4938,	-0.472,	-0.4513,	-0.4316,	-0.4129,	-0.3952,	-0.3783,	-0.3623,	-0.3471,	-0.3326,	-0.3188,	-0.3058,	-0.2934,	-0.2816;
// values for 'd'

var y; // SHOCK e2 (d)
//periods 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20;
//values -2.641074678	-2.61679309	-2.574836536	-2.529839855	-2.485688254	-2.443357655	-2.403036334	-2.364701024	-2.328273954	-2.293665785	-2.260787308	-2.229552541	-2.199879448	-2.171689989	-2.144909997	-2.119469002	-2.095300056	-2.072339558	-2.050527084	-2.029805234;
//values -12.64107468 -12.00902094	-11.4085699	-10.8381414	-10.29623433	-9.781422615	-9.292351485	-8.82773391	-8.386347215	-7.967029854	-7.568678361	-7.190244443	-6.830732221	-6.48919561	-6.16473583	-5.856499038	-5.563674086	-5.285490382	-5.021215863	-4.77015507;
//values -7.94107468	-11.11750455	-12.22925501	-9.783404006	-7.826723205	-6.261378564	-1.878413569	-0.563524071	-0.169057221	-0.050717166	-0.01521515	-0.004564545	-0.001369363	-0.000410809	-0.000123243	-3.69728E-05	0	0	0	0; 
periods 1 2 3 4 5 6 7 8 9 10;
////KIEV May 2020 below
//values -7.94107468	-11.11750455	-12.22925501	-8.400207247	-6.104449436	-4.653712243	-3.695128934	-3.037282286	-2.571061018	-2.231492986;
////JMCB Revision and corrected for ss
values -10.187	-8.252825	-7.224054031	-6.1009438	-5.611120211	-4.315557022	-3.442347433	-2.85380417	-2.45712601	-2.189764931;
//JMCB REVISION: Scaled to match NFB sector and corrected for ss
//values -14.03184472	-11.22789165	-9.736493235	-8.108332192	-7.398240107	-6.822116096	-6.303604487	-5.836944038	-5.416949634	-5.038954671;



//var ho;
//periods 1 2 3 4 5 6 7 8 9 10;
//values -12 -12 -6 -6 0 0 0 0 0 0;

//var n;
//periods 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20;
//values -7.748669149	-9.52915355	-9.65062297	-9.314015075	-8.862170785	-8.393712863	-7.936844583	-7.499188133	-7.082281807	-6.685862109	-6.309148246	-5.951232657	-5.611200564	-5.288166005	-4.981281819	-4.689741384	-4.412777817	-4.149662382	-3.899702697	-3.662240992;
//periods 1;
//values -7.7487;

//var v;
//periods 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20;
//values -27.56979533 -26.19130557	-24.88174029	-23.63765328	-22.45577061	-21.33298208	-20.26633298	-19.25301633	-18.29036551	-17.37584724	-16.50705487	-15.68170213	-14.89761702	-14.15273617	-13.44509936	-12.7728444	-12.13420218	-11.52749207	-10.95111746    -10.436;
//values -2.641074678	-2.61679309	-2.574836536	-2.529839855	-2.485688254	-2.443357655	-2.403036334	-2.364701024	-2.328273954	-2.293665785	-2.260787308	-2.229552541	-2.199879448	-2.171689989	-2.144909997	-2.119469002	-2.095300056	-2.072339558	-2.050527084	-2.029805234;

//////////var d; // SHOCK: e2
//periods 1; // 2 3;
//periods 1:20 ;
//values 0; //-1.5,-2.5,-3.5; //-1.5075;  // Benchmark shock (to compare with IRF) (Same result as path below)
//values -1.5075,-1.4321, -1.3605, -1.2925, -1.2279, -1.1665, -1.1081, -1.0527, -1.0001, -0.9501, -0.9026, -0.8575, -0.8146, -0.7739, -0.7352, -0.6984, -0.6635, -0.6303, -0.5988, -0.5689; 
//periods 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20;
//values -14.45081308	-13.32931645	-12.45369966	-11.67842771	-10.95898827	-10.28073292	-9.63799922	-9.027903574	-8.448470217	-7.898058325	-7.375182843	-6.87845618	-6.40656746	-5.958273692	-5.532394775	-5.127809858	-4.743454204	-4.378316334	-4.031435363	-3.70189844;
///////periods 1 2 3 4 5 6 7 8 9 10;
// CORRECTED PAPER VALUES
//////////values -7.805973306	-11.71534773	-12.92434073	-8.444821183	-5.719931694	-3.916982876	-2.663815368	-1.765138658	-1.105701345	-0.612529408;
////JMCB Revision and corrected for ss JOLTS
//values -11.88939504	-8.875286728	-8.533331786	-6.831588844	-6.122123534	-5.523445606	-4.975133244	-4.47881806	-4.031289134	-3.628261003;
////JMCB Revision and corrected for ss CPS (rho = 0.695)
/////////values -9.681066062	-7.07151658	-6.305315621	-5.265148707	-5.044878677	-3.37090476	-2.263164949	-1.522708029	-1.02548989	-0.690920601;
////JMCB Revision and corrected for ss CPS USE FOR RHO = 0.95
//values -10.49260443	-7.519188844	-6.771195763	-5.699188668	-5.539867182	-5.324678985	-5.022243307	-4.675540712	-4.312943541	-3.952426861;
//RHO =0.695 AND omega = 0.25
//values -8.251416191	-6.303474835	-5.50182108	-4.499259704	-4.179410121	-2.747613257	-1.804563412	-1.18924751	-0.785851766	-0.52037103;




//PAPER VALUES
//values -7.769480066	-11.66139733	-12.85185976	-8.414221491	-5.71331857	-3.920265832	-2.667968507	-1.765532012	-1.100552228	-0.601585267;
//values -15 -15 -15 0 0 0 0 0 0 0;


//var kjobw;
//periods 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20;
//values -19.50481239	-17.36433791	-16.06147291	-15.06075104	-14.18885433	-13.38730165	-12.6350645	-11.92367196	-11.24899143	-10.6084514	-10.00008365	-9.422186368	-8.873202646	-8.351674819	-7.856225799	-7.385550089	-6.938408477	-6.513624064	-6.110078903	-5.726711018;
//values -21.45529363	-19.1007717	-17.6676202	-16.56682614	-15.60773976	-14.72603181	-13.89857095	-13.11603916	-12.37389058	-11.66929654	-11.00009202	-10.36440501	-9.76052291	-9.186842301	-8.641848379	-8.124105098	-7.632249325	-7.164986471	-6.721086793	-6.29938212;
//values -39.00962478	-34.72867582	-32.12294581	-30.12150207	-28.37770866	-26.77460329	-25.27012899	-23.84734393	-22.49798287	-21.21690279	-20.0001673	-18.84437274	-17.74640529	-16.70334964	-15.7124516	-14.77110018	-13.87681695	-13.02724813	-12.22015781	-11.45342204


end;	

conditional_forecast(parameter_set=calibration, controlled_varexo=(e1, e2), periods=10);
//conditional_forecast(parameter_set=calibration, controlled_varexo=(e1), periods=10);
//plot_conditional_forecast(periods=20)  d;
// jturn wturn kwl kfh kfl kjobw kjobf holav s lambda hobar h v gamat xit sh sl nh nl n rhot uh ul u th kw kf rhon q ctot y rn c abar mu ql wul ho surph qh wuh x Pi pnum pdenom f z d m rntrue;  



//carl200plot
