%// PARAMETERIZATIONS
%// US = 1 to get us parameterization.
%// else
%// get baseline (EU) parameterization.
%fwuhom
% nocomp_us = 1
% gives parameterization with no comp effect for us 
% nocomp_eu = 1
% gives parameterization with no comp effect for eu
%
% else: standard comp effect

%// PARAMETERS can be modified manually at end of each loop (US or EU)
%// AT END OF EU LOOP:
%// %%% CALIBRATION TO PRODUCE LARGE LABOR FLOWS WITH eu PARAMETERIZATIONS
%// %Alternative calibration no comp effect
%// %same Y, u.

% INPUT PARAMETERS AT END OF each if LOOP


% parameters and steady state computation 
% policy and exog disturbances parameters

chi = 0%0.8; %chi = 0 for u-rule             
omegap = 1.5%1.5%1.65;
omegay = 0%0 0.15;  %0.1 for u-rule, 0.3 for y-rule
rhoz = 0.695%0.95;
rhod = 0.695; %0.95
rhom = 0.96%0.989;             
quad = 1 % EXPONENT OF VACANCIES FOR posting cost.  1=linear, 2 = quadratic


us = 1 %Set to 1 for market, 0 for planner
nocomp_us = 0
nocomp_eu = 0

if us == 1 %MARKET EQUILIBRIUM
sigm = 1;  %use log utility to compute welfare
phi = 0 ;  %habit formation
eta = 0.6; %0.35   %share of surplus to worker
chi_ho = 1%%%1.3%1.02%1.02 %%0.8   %2.5   %inverse of labor hours supply elasticity
disc = 0.99;            
thetap = 0.75;  %set to 0 for flexible prices
%thetap = 0;
theta = 11;
%mubar = theta/(theta-1);
mubar = 1;
mu_ss = mubar;
alpha = 0.6%0.6;    %     %elasticity matching function

kf_ss = 0.9%0.9;           % ss pr of filling a vacancy
Pi_ss = 1.00;               %ss inflation (quarterly)
ho_ss = 0.35;%0.35  ;             %ss hours for high-skilled
KK = 0.015%51531325 %0.0325 %%0.0110 ; %0.025 high low skill u-volatility, 0.045 kappa*V/Y: ss output share of vacancy posting expenditure

f_ss = 1;           %ss price dispersion
z_ss = 1;           %ss productivity

% First FSOLVE call parameters
n_ss = 1-0.056; 

% OLD CALIBRATION n_ss = 0.954;

rhox = 0.068%0.055%0.068 %%0.63; %0.468 high low skill u-volatility,  0.068

% OLD CALIBRATION
%HH = 0.105; % sh_ss/(1-gamabar) = 0.02;
%GG=0.215; %sl_ss/gamabar = 0.15;   Note: higher GG raises a_ss, and unempl duration for l-worker, but also lowers gamabar

HH = 0.1%0.075%0.1%0.11%0.11; % sh_ss/(1-gamabar) = 0.02;
GG= 0.2%0.15%0.2 % 0.1537%0.175; %sl_ss/gamabar = 0.15;   Note: higher GG raises a_ss, and unempl duration for l-worker, but also lowers gamabar


carl200steady
psi
kappa
wuhome_h
gamabar
zh_ss
ell
n_ss
omegay
display('Solution parameters above // below planners parameters loaded from steadystate_plan.mat')
%psi	= 0.6988
%ell	=	8.6799
%wuhome_h	= 0.0594
%kappa	=	0.0387
%zh_ss	=	0.5978
%gamabar = 0.1853


load steadystate_plan.mat steadystate_parameters
%CHI=1.3
%ell = 11.4662
%kappa = 0.0354
%wuhome_h = 0.0681
%zh_ss = 0.5297
%gamabar = 0.1853
psi = steadystate_parameters(41)
ell = steadystate_parameters(47)
kappa = steadystate_parameters(58)
wuhome_h = steadystate_parameters(53)
zh_ss = steadystate_parameters(52)
gamabar = steadystate_parameters(6)
pause

% Parameters computed from ss data OLD US CALIBRATION JUNE 2009
% can change at this stage each single paramater

%kappa = 0.0118; %0.118 %vacancy posting cost
%gamabar = 0.05344; %0.0534    %share of labor force l-skill
%psi = 0.2596;  %0.6520     %TFP matching function
%ell =  50.617;   %50.617      %disutility of labor scaling
%wuhome_h = 0.0791; %0.0791 %home production value
%zh_ss = 0.7381;  %0.7381    %TFP h-skill = z(t)*zh_ss
                    %zh_ss = ratio productivity h-skill to best l_skill

                  %worker


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Parameters computed from ss data OLD US CALIBRATION

%kappa = 0.0107;  %vacancy posting cost
%gamabar = 0.1568;    %share of labor force l-skill
%psi = 0.2516;       %TFP matching function
%ell =  52.54;        %disutility of labor scaling
%wuhome_h = 0.0795; %home production value
%zh_ss = 0.7203;    %TFP h-skill = z(t)*zh_ss
                    %zh_ss = ratio productivity h-skill to best l_skill

                  %worker
zl_ss = 1;

if nocomp_us == 1
  zh_ss=0.5918*0.95 %0.653%0.63  %0.76  % baseline0.63  
zl_ss = 1*1.12%1%0.8 %baseline1
psi = 0.6988*1.2%0.87%0.87%0.8   %baseline0.7
kappa = 0.0384*0.65%0.045%0.05%0.05 %baseline0.08
else
end

quad_ = quad
chi_ = chi
omegap_=omegap;
omegay_=omegay;
rhoz_ = rhoz;
rhod_ = rhod;
rhom_ = rhom;      
holav_ss_ = holav_ss 
n_ss_ = n_ss
rhox_=rhox;
sl_ss_=sl_ss
 sh_ss_=sh_ss
gamabar_=gamabar 
s_ss_=s_ss;
 gamat_ss_= gamat_ss
 nh_ss_= nh_ss
 nl_ss_= nl_ss
 xit_ss_= xit_ss
kw_ss_=kw_ss
 h_ss_= h_ss
 rhon_ss_= rhon_ss
 rhot_ss_= rhot_ss;
 mubar_= mubar;
 sigm_= sigm;
 disc_= disc;
 phi_= phi;
 chi_ho_= chi_ho
 thetap_= thetap;
 theta_= theta;
alpha_=alpha;
 kf_ss_= kf_ss;
 Pi_ss_= Pi_ss;
 ho_ss_= ho_ss
 f_ss_= f_ss;
 z_ss_= z_ss;
 KK_= KK;
 mu_ss_=mu_ss;
 a_ss_= a_ss;
 eta_= eta;
 v_ss_= v_ss
 HH_= HH;
 GG_=GG;
ul_ss_=ul_ss
 uh_ss_= uh_ss
 unempl_duration_h_ss_= unempl_duration_h_ss
 unempl_duration_l_ss_= unempl_duration_l_ss
 ratio_duration_ss_= ratio_duration_ss
psi_=psi
 theta_ss_= theta_ss
 c_ss_= c_ss
 y_ss_= y_ss
  q_ss_= q_ss
 lambda_ss_= lambda_ss;
 ell_= ell
 ctot_ss_= ctot_ss
 wuh_ss_= wuh_ss;
 surph_ss_= surph_ss
 qh_ss_= qh_ss;
zh_ss_=zh_ss
 wuhome_h_= wuhome_h
 hobar_ss_= hobar_ss
 wul_ss_= wul_ss
 ql_ss_= ql_ss;
 x_ss_= x_ss
 kappa_= kappa
 rn_ss_= rn_ss;
 mc_ss_= mc_ss;
 u_ss_= u_ss;
jd_ss_=jd_ss
 jc_ss_= jc_ss
 jturn_ss_= jturn_ss
 wturn_ss_= wturn_ss
 kwl_ss_= kwl_ss
 kfh_ss_= kfh_ss
 kfl_ss_= kfl_ss
 kjobw_ss_= kjobw_ss
 kjobf_ss_= kjobf_ss
 holav_ss_= holav_ss
 zl_ss_=zl_ss

else                  %PLANNER EQUILIBRIUM

sigm = 1;  %use log utility to compute welfare
phi = 0 ;  %habit formation
eta = 0.6; %0.35   %share of surplus to worker
chi_ho = 1%1.02%1.02 %%0.8   %2.5   %inverse of labor hours supply elasticity
disc = 0.99;            
thetap = 0.75%.75;  %set to 0 for flexible prices
%thetap = 0;  %set to 0 for flexible prices
theta = 6;
%mubar = theta/(theta-1);
mubar = 1;
mu_ss = mubar;
alpha = 0.6%0.6;    %     %elasticity matching function


Pi_ss = 1.00;               %ss inflation (quarterly)
KK = 0.01551531325 %0.0325 %%0.0110 ; %0.025 high low skill u-volatility, 0.045 kappa*V/Y: ss output share of vacancy posting expenditure

f_ss = 1;           %ss price dispersion
z_ss = 1;           %ss productivity



rhox = 0.068%0.068 %%0.63; %0.468 high low skill u-volatility,  0.068

% OLD CALIBRATION
%HH = 0.105; % sh_ss/(1-gamabar) = 0.02;
%GG=0.215; %sl_ss/gamabar = 0.15;   Note: higher GG raises a_ss, and unempl duration for l-worker, but also lowers gamabar

HH = 0.11%0.11; % sh_ss/(1-gamabar) = 0.02;
GG=0.1537%0.175; %sl_ss/gamabar = 0.15;   Note: higher GG raises a_ss, and unempl duration for l-worker, but also lowers gamabar
% First FSOLVE call parameters
n_ss = 0.9440; 
ho_ss = 0.35  ;             %ss hours for high-skilled
kf_ss = 0.9;%0.9;           % ss pr of filling a vacancy

% PLANNER parameters for convergence
HH = 0.11%0.11; % sh_ss/(1-gamabar) = 0.02;
GG=0.165%0.165; %sl_ss/gamabar = 0.15;   Note: higher GG raises a_ss, and unempl duration for l-worker, but also lowers gamabar
n_ss = 0.944%0.9440; 
ho_ss = 0.3506%0.35  ;             %ss hours for high-skilled
kf_ss = 0.8859%0.8845;%0.9;

carl200steady_plan
%carl200steady_plan_NEW

zl_ss = 1;



display('PLANNER EQUILIBRIUM - parameters from market equi')
ell
kappa
psi
wuhome_h
zh_ss
pause
gamabar = 0.233227    %share of labor force l-skill
psi = 0.698797      %TFP matching function
kappa = 0.0382728 %vacancy posting cost
ell =  8.659787      %disutility of labor scaling
wuhome_h = 0.0590027 %home production valxue
%zh_ss = 0.590294     %TFP h-skill = z(t)*zh_ss
   %zh_ss = 0.5978                  %zh_ss = ratio productivity h-skill to best l_skill
                    %worker
 
                    % planner endog - TRIAL
%kappa = 0.0385598 %vacancy posting cost
%ell =  8.7112      %disutility of labor scaling
%wuhome_h = 0.0592467 %home production valxue
%zh_ss = 0.5978
%ho_ss
pause

quad_ = quad
chi_ = chi
omegap_=omegap;
omegay_=omegay;
rhoz_ = rhoz;
rhod_ = rhod;
rhom_ = rhom;      
holav_ss_ = holav_ss 
n_ss_ = n_ss
rhox_=rhox;
sl_ss_=sl_ss
 sh_ss_=sh_ss
gamabar_=gamabar 
s_ss_=s_ss;
 gamat_ss_= gamat_ss
 nh_ss_= nh_ss
 nl_ss_= nl_ss
 xit_ss_= xit_ss
kw_ss_=kw_ss
 h_ss_= h_ss
 rhon_ss_= rhon_ss
 rhot_ss_= rhot_ss;
 mubar_= mubar;
 sigm_= sigm;
 disc_= disc;
 phi_= phi;
 chi_ho_= chi_ho
 thetap_= thetap;
 theta_= theta;
alpha_=alpha;
 kf_ss_= kf_ss;
 Pi_ss_= Pi_ss;
 ho_ss_= ho_ss
 f_ss_= f_ss;
 z_ss_= z_ss;
 KK_= KK;
 mu_ss_=mu_ss;
 a_ss_= a_ss;
 eta_= eta;
 v_ss_= v_ss
 HH_= HH;
 GG_=GG;
ul_ss_=ul_ss
 uh_ss_= uh_ss
 unempl_duration_h_ss_= unempl_duration_h_ss
 unempl_duration_l_ss_= unempl_duration_l_ss
 ratio_duration_ss_= ratio_duration_ss
psi_=psi
 theta_ss_= theta_ss
 c_ss_= c_ss
 y_ss_= y_ss
  q_ss_= q_ss
 lambda_ss_= lambda_ss;
 ell_= ell
 ctot_ss_= ctot_ss
 wuh_ss_= wuh_ss;
 surph_ss_= surph_ss
 qh_ss_= qh_ss;
zh_ss_=zh_ss
 wuhome_h_= wuhome_h
 hobar_ss_= hobar_ss
 wul_ss_= wul_ss
 ql_ss_= ql_ss;
 x_ss_= x_ss
 kappa_= kappa
 rn_ss_= rn_ss;
 mc_ss_= mc_ss;
 u_ss_= u_ss;
jd_ss_=jd_ss
 jc_ss_= jc_ss
 jturn_ss_= jturn_ss
 wturn_ss_= wturn_ss
 kwl_ss_= kwl_ss
 kfh_ss_= kfh_ss
 kfl_ss_= kfl_ss
 kjobw_ss_= kjobw_ss
 kjobf_ss_= kjobf_ss
 holav_ss_= holav_ss
 zl_ss_=zl_ss
 
pause
                    
 
end