function [ys,params,check] = carl202zlb_cond_market_steadystate(ys,exo,M_,options_)



%% Step 0: initialize indicator and set options for numerical solver
check = 0;
options = optimset('Display','Final','TolX',1e-10,'TolFun',1e-10);

%% Step 1: read out parameters to access them with their name
for ii = 1:M_.param_nbr
  eval([ M_.param_names{ii} ' = M_.params(' int2str(ii) ');']);
end


%% Step 3: Enter model equations here AND parameters

noload = 0;
if noload==1
    display('LOADING VALUES WRITTEN IN steadystate FILE')
    pause
jd     		 =-4.3391;
jc     		 =-4.3391;
jturn  		 =-3.64596;
wturn  		 =-1.9626;
kwl    		 =-0.566995;
kfh    		 =-0.398917;
kfl    		 =-1.51415;
kjobw  		 =-0.537087;
kjobf  		 =-0.115364;
holav  		 =-1.19001;
s      		 =-2.11866;
lambda 		 =1.62576;
hobar  		 =-3.77623;
h      		 =-2.65575;
v      		 =-2.54039;
gamat  		 =-1.36888;
xit    		 =-1.738;
sh     		 =-2.41222;
sl     		 =-3.48754;
nh     		 =-0.251058;
nl     		 =-1.79563;
n      		 =-0.0576291;
rhot   		 =-2.59812;
uh     		 =-3.09966;
ul     		 =-2.26262;
u      		 =-2.8824;
th     		 =-0.421723;
kw     		 =-0.527084;
kf     		 =-0.105361;
rhon   		 =-3.24098;
q      		 =-1.62717;
ctot   		 =-1.62576;
y      		 =-1.62717;
rn     		 =0.0100503;
c      		 =-1.64281;
abar   		 =-3.24098;
mu     		 =0;
ql     		 =2.21618;
wul    		 =2.21623;
ho     		 =-1.04982;
surph  		 =-2.20446;
qh     		 =2.25665;
wuh    		 =2.25598;
x      		 =-2.27345;
Pi     		 =0;
pnum   		 =1.35532;
pdenom 		 =1.35532;
f      		 =0;
z      		 =0;
d      		 =0;
m      		 =0;
rntrue 		 =0.0100503;

else
end

%Write here steady state values, 
%'jd = XXX' etc.
%OR
% load from former 'save' instruction

%% Step 4: Update parameters and variables
params=NaN(M_.param_nbr,1);

if noload ==1
    
for iter = 1:M_.param_nbr %update parameters set in the file
  
    eval([ 'params(' num2str(iter) ') = ' M_.param_names{iter} ';' ])
%thetap correction
params(21) = thetap;
    end

for ii = 1:M_.orig_endo_nbr %auxiliary variables are set automatically
  eval(['ys(' int2str(ii) ') = ' M_.endo_names{ii} ';']) %USE IF ASSIGNING
  %VALUES WRITING IN FILE 'jd = XXX' etc. 
end

else
load('steadystate_plan.mat')
for iter = 1:M_.param_nbr %update parameters set in the file
  %eval([ 'params(' num2str(iter) ') = ' M_.param_names{iter} ';' ])
  eval([ 'params(' num2str(iter) ') = steadystate_parameters(iter) ;' ])
  params(21) = thetap;
  params(62) = chi;
  params(63) = omegap;
  params(64) = omegay;
  params(25) = Pi_ss;
%  params(47)=10
  end
for ii = 1:M_.orig_endo_nbr %auxiliary variables are set automatically
  %eval(['ys(' int2str(ii) ') = ' M_.endo_names{ii} ';']) %USE IF ASSIGNING
  %VALUES WRITING IN FILE 'jd = XXX' etc.
%  eval(['ys(' int2str(ii) ') =  oo_.steady_state(ii) ;']) %Use if saving
%  all variables from desired dynare model that we want to use ss of
  eval(['ys(' int2str(ii) ') =  steadystate_variables(ii) ;']) %Use after 
  % instructions
  %%steadystate_variables = oo_.steady_state
  %steadystate_parameters = M_.params
  %%save steadystate_plan.mat steadystate_variables steadystate_parameters
end
end
display('END steady_state FUNCTION')
