%clear all
close all
global y x n_ss rhox sl_ss sh_ss gamabar s_ss gamat_ss nh_ss nl_ss xit_ss
global kw_ss h_ss rhon_ss rhot_ss mubar sigm disc phi chi_ho thetap theta
global alpha kf_ss Pi_ss ho_ss f_ss z_ss KK mu_ss a_ss eta v_ss quad

% Second FSOLVE call parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% BELOW: USE ONLY FOR RUNNING FILES WITHOUT
% THE carlXXXparameters.m file

%sigm = 1;  %use log utility to compute welfare
%phi = 0  ;  %habit formation
%eta = 0.4; %   %share of surplus to worker
%chi_ho = 2.5   %   %inverse of labor hours supply elasticity
%disc = 0.99;            
%thetap = 0.7;  %set to 0 for flexible prices
%theta = 6;
%mubar = 1;
%mu_ss = mubar;
%alpha = 0.6;    %     %elasticity matching function

%kf_ss = 0.7;           % ss pr of filling a vacancy
%Pi_ss = 1.0;               %ss inflation (quarterly)
%ho_ss = 0.335  ;             %ss hours for high-skilled
%KK = 0.05  ; %0.025 high low skill u-volatility, 0.045 kappa*V/Y: ss output share of vacancy posting expenditure

%f_ss = 1;           %ss price dispersion
%z_ss = 1;           %ss productivity

% First FSOLVE call parameters
%n_ss = 0.954;
%rhox = 0.068; %0.468 high low skill u-volatility,  0.068


%HH = 0.105; % sh_ss/(1-gamabar) = 0.02;
%GG=0.215; %sl_ss/gamabar = 0.15;   Note: higher GG raises a_ss, and unempl duration for l-worker, but also lowers gamabar

%%%%%%%%%%%%%%%%%%%%% First set of steady state computation: 
%%%%%%%%%%%%%%%%%%%%% accounting block

%10
s_ss = 1-(1-rhox)*n_ss

%accounting
%sl_ss = s_ss-sh_ss

sl_ss = (s_ss-HH)/(1-HH/GG)
gamabar = sl_ss/GG
sh_ss = HH*(1-gamabar)

%1
gamat_ss = sl_ss/s_ss
%gg+hh
nh_ss = (sl_ss-gamabar)/(1-rhox)+n_ss
%substitutes gamat equation
nl_ss = n_ss-nh_ss
%2
xit_ss = nl_ss/n_ss

check = (gamabar-(1-rhox)*xit_ss*n_ss)/s_ss

% First FSOLVE call
carl200_ss1

kw_ss = x(1)
rhon_ss = x(2)
h_ss = x(3)

ul_ss = 1-nl_ss/gamabar
uh_ss = 1-nh_ss/(1-gamabar)

u_ss = 1-n_ss;

rhot_ss = rhox+(1-rhox)*xit_ss*rhon_ss

unemp_share_l = (gamabar-nl_ss)/(1-n_ss)
unemp_share_h = (1-gamabar-nh_ss)/(1-n_ss)

searchers_ownshare_h = sh_ss/(1-gamabar)

separate_l = rhox+(1-rhox)*rhon_ss  %separation rate l-workers

unempl_duration_h_ss = 1/kw_ss
unempl_duration_l_ss = 1/(kw_ss*(1-rhon_ss))
ratio_duration_ss = unempl_duration_l_ss/unempl_duration_h_ss

%%%%%%%%%%%%%%%%%%%%% Second set of steady state computation

%17
a_ss=rhon_ss;

% 15,16,14
psi=kf_ss^(1-alpha)*kw_ss^alpha;
theta_ss = kw_ss/kf_ss;
v_ss=theta_ss*s_ss;

% Second FSOLVE call
[x, fval, exitflag]=carl200_ss4

c_ss=x(1)
y_ss=x(2)
q_ss=x(3);
lambda_ss = x(4);
ell=x(5)
ctot_ss = x(6)
wuh_ss=x(7)
surph_ss=x(8)
qh_ss = x(9)
zh_ss = x(10)
wuhome_h = x(11)
hobar_ss = x(12)
wul_ss = x(13)
ql_ss = x(14)
x_ss = x(15)

%kappa = KK*y_ss/v_ss;
%Quadratic cost of adjustment
kappa = KK*y_ss/(v_ss^quad);
v_ss;
psi;
zh_ss

% average hours l-workers
holav_ss = (lambda_ss*z_ss/(mu_ss*ell))^(1/chi_ho)*(1-a_ss^(1+1/chi_ho))/((1-a_ss)*(1+1/chi_ho))
%average hours per worker
hours_average = (ho_ss*nh_ss+holav_ss*nl_ss)/n_ss
%ratio total consumption to market consumption
ratio_ctot_cmarket = ctot_ss/c_ss
%consumption ratio for individual worker (with no insurance)
ratio_homeproduction_cmarket_perworker = ((ctot_ss-c_ss)/(1-n_ss))/(c_ss/n_ss)
ratio_homeproduction_cmarket_perworker_check = (wuhome_h)/(c_ss/n_ss)
%average productivity advantage of h-worker
ratio_av_productivity = z_ss*zh_ss/(z_ss/2)

% pricing block
% eqs 22, eqs 34 to 38

%38 Free variable: ss policy
% set as Pi_ss at beginning of file

% 22 
rn_ss = 1/disc;

%37, 35, 36, 34 
mc_ss = (1/Pi_ss)*(1/mubar)*(((Pi_ss^(1-theta)-thetap)/(1-thetap))^(1/(1-theta)))*((1-thetap*disc*Pi_ss^theta)/(1-thetap*disc*Pi_ss^(theta-1)));
pnum_pdenom_ratio = mubar*mc_ss*(1-thetap*disc*(Pi_ss)^(theta-1))/(1-thetap*disc*(Pi_ss)^theta);
f_ss = (((pnum_pdenom_ratio)^(-theta))*(1-thetap)/(1-thetap*Pi_ss^theta));

% additional variables

jd_ss = (rhox+rhon_ss*(1-rhox)*xit_ss-rhox*(h_ss/v_ss))*n_ss
jc_ss = kf_ss*h_ss/(kw_ss*s_ss)*(v_ss-rhox*n_ss)
jturn_ss = jc_ss+jd_ss
wturn_ss = rhot_ss*n_ss+h_ss
kwl_ss = kw_ss*(1-a_ss)
kfh_ss = kf_ss*(1-gamat_ss)
kfl_ss = kf_ss*gamat_ss*(1-a_ss)
kjobw_ss = gamat_ss*kwl_ss+(1-gamat_ss)*kw_ss
kjobf_ss = kfl_ss+(1-gamat_ss)*kf_ss

screening_rate_percent = gamat_ss*rhon_ss*100







