clear all
close all

% Federico Update 7 May 2020
%Produces specific set of plots, for paper
%used to compare baseline vs alternative
%loads data, so can also be used with single baseline experiment
%first needs to use carl200plot_e1_XXXXXX
%
%Built from irf_carl200_dem_persistent.m
%Added at end part of irf_carl200_dem_ZLB.m

% reads the IRF variables generated by Dynare
% listed as : 'variable name in lgy_''name of shock'
% generated by carl200 and carl200_eu

% BENCHMARK: std IT, policy_bbench // SOLID
solid = ['Policy(1): Respond to inflation (benchmark)'] 
% POLICY A: Expansionary omegay*N,omegay=0.39 policy_aa //DASHED
dashed = ['Policy(2): Respond to unemployment'] 
% POLICY B: Expansionary omegay*Nl,omegay=0.5 policy_bb //DOTTED
dotted = ['Policy (3): Respond to L-unemployment'] 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% FIGURE 1POLICY - Unempl rate, PP from ss (subtract ss), and UNEMP SHARE
%%% l-WORKERS
%%%%% COLOR AREA so areas sum

load policy_bbench
HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];

share_nl = nl_e1*nl_ss./(n_e1*n_ss)*100;
share_nh = nh_e1*nh_ss./(n_e1*n_ss)*100;
share_scaled_ul = share_nl.*(u_e1*u_ss)/100
share_scaled_uh = share_nh.*(u_e1*u_ss)/100

irf_policy_bbench = [unempl, share_scaled_ul];

u_diff = [];
u_d_cumul = [];
ineq_ratio = [];
symm_infl_cost = [];

ul_cumul = ones(1,10) ;
uh_cumul = ones(1,10);
y_cumul = ones(1,10);
Pi_cumul =  ones(1,10);
Pi_cumul(1)=nan;

for count = 1:size(xit_e1,1)
    ul_cumul(count) = sum(share_scaled_ul(1:count,1));
    uh_cumul(count) = sum(share_scaled_uh(1:count,1));
    y_cumul(count) = sum(y_e1(1:count,1));
    ineq_ratio(count) = ul_cumul(count)/uh_cumul(count);
end

display('initial level unemployment for sacrifice ratio')
u_initial = 5.9491
pause

u_diff = unempl(2:size(xit_e1,1)) - u_initial;
u_diff = [0; u_diff];
for count = 1:size(xit_e1,1)
    Pi_cumul(count) = sum(abs(Pi_e1(2:count,1)));
    u_d_cumul(count) = sum(u_diff(1:count,1));
end

u_d_cumul(1) = nan;
u_diff(1) = nan;
Pi_cumul(1)=nan;
symm_infl_cost_cumul = Pi_cumul./u_d_cumul;
symm_infl_cost = Pi_cumul'./u_diff;

display('policy bbench') 
display('sac ratio // sac ratio CUMUL //  ineq ratio // cumul y // cumul ul_share // cumul uh_share')
policy_matrix = [-symm_infl_cost(8), -symm_infl_cost_cumul(8), ineq_ratio(8), y_cumul(8), ul_cumul(8), uh_cumul(8)]
pause



load policy_bb
HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];

share_nl = nl_e1*nl_ss./(n_e1*n_ss)*100;
share_nh = nh_e1*nh_ss./(n_e1*n_ss)*100;
share_scaled_ul = share_nl.*(u_e1*u_ss)/100;
share_scaled_uh = share_nh.*(u_e1*u_ss)/100;

irf_policy_bb = [unempl, share_scaled_ul];

u_diff = [];
u_d_cumul = [];
ineq_ratio = [];
symm_infl_cost = [];

ul_cumul = ones(1,10) ;
uh_cumul = ones(1,10);
y_cumul = ones(1,10);
Pi_cumul =  ones(1,10);
Pi_cumul(1)=nan;

for count = 1:size(xit_e1,1)
    ul_cumul(count) = sum(share_scaled_ul(1:count,1));
    uh_cumul(count) = sum(share_scaled_uh(1:count,1));
    y_cumul(count) = sum(y_e1(1:count,1));
    ineq_ratio(count) = ul_cumul(count)/uh_cumul(count);
end

u_diff = unempl(2:size(xit_e1,1)) - u_initial;
u_diff = [0; u_diff];
for count = 1:size(xit_e1,1)
    Pi_cumul(count) = sum(abs(Pi_e1(2:count,1)));
    u_d_cumul(count) = sum(u_diff(1:count,1));
end

u_d_cumul(1) = nan;
u_diff(1) = nan;
Pi_cumul(1)=nan;
symm_infl_cost_cumul = Pi_cumul./u_d_cumul;
symm_infl_cost = Pi_cumul'./u_diff;

display('policy bb') 
display('sac ratio // sac ratio CUMUL //  ineq ratio // cumul y // cumul ul_share // cumul uh_share')
policy_matrix = [-symm_infl_cost(8), -symm_infl_cost_cumul(8), ineq_ratio(8), y_cumul(8), ul_cumul(8), uh_cumul(8)]

pause


load policy_aa
HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];

share_nl = nl_e1*nl_ss./(n_e1*n_ss)*100;
share_nh = nh_e1*nh_ss./(n_e1*n_ss)*100;
share_scaled_ul = share_nl.*(u_e1*u_ss)/100;
share_scaled_uh = share_nh.*(u_e1*u_ss)/100;

irf_policy_aa = [unempl, share_scaled_ul];

u_diff = [];
u_d_cumul = [];
ineq_ratio = [];
symm_infl_cost = [];

ul_cumul = ones(1,10) ;
uh_cumul = ones(1,10);
y_cumul = ones(1,10);
Pi_cumul =  ones(1,10);
Pi_cumul(1)=nan;

for count = 1:size(xit_e1,1)
    ul_cumul(count) = sum(share_scaled_ul(1:count,1));
    uh_cumul(count) = sum(share_scaled_uh(1:count,1));
    y_cumul(count) = sum(y_e1(1:count,1));
    ineq_ratio(count) = ul_cumul(count)/uh_cumul(count);
end

u_diff = unempl(2:size(xit_e1,1)) - u_initial;
u_diff = [0; u_diff];
for count = 1:size(xit_e1,1)
    Pi_cumul(count) = sum(abs(Pi_e1(2:count,1)));
    u_d_cumul(count) = sum(u_diff(1:count,1));
end

u_d_cumul(1) = nan;
u_diff(1) = nan;
Pi_cumul(1)=nan;
symm_infl_cost_cumul = Pi_cumul./u_d_cumul;
symm_infl_cost = Pi_cumul'./u_diff;

display('policy aa') 
display('sac ratio // sac ratio CUMUL //  ineq ratio // cumul y // cumul ul_share // cumul uh_share')
policy_matrix = [-symm_infl_cost(8), -symm_infl_cost_cumul(8), ineq_ratio(8), y_cumul(8), ul_cumul(8), uh_cumul(8)]

pause

   newpp=[0.25 , 0.25 , 8, 8];
      grid on
set(gcf,'PaperOrientation','portrait')
set(gcf,'PaperPosition',newpp)

newpp=[0.25 , 0.25 , 8, 8];
      grid on
set(gcf,'PaperOrientation','portrait')
set(gcf,'PaperPosition',newpp)
%set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',{'1', '2', '3', '4', '5'})
%set(findobj('Type','line'),'LineWidth',2)

    subplot(1,2,1),plot(Time_axis,irf_policy_bbench(:,1),'k',...
        Time_axis,irf_policy_aa(:,1),'--k.',Time_axis,irf_policy_bb(:,1),'-.k',Time_axis,zzero(1,:),':')
   
xlim([1 HORIZON]);
    grid on
		legend(solid, dashed, dotted)
 grid on
 title('Unemployment Rate - log-change ')
 
   subplot(1,2,2),plot(Time_axis,irf_policy_bbench(:,2),'k',...
        Time_axis,irf_policy_aa(:,2),'--k.',Time_axis,irf_policy_bb(:,2),'-.k',Time_axis,zzero(1,:),':')
   
   
xlim([1 HORIZON]);
ylim([0 6]);
    grid on
		legend(solid, dashed, dotted)
 grid on
 title('Unemployment share - low efficiency workers')
 
 %   set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',{'1', '2', '3', '4', '5'})
set(findobj('Type','line'),'LineWidth',1)

figure

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% FIG B_TEMP OLD/   surph, abar*abar_ss, avg l-earnings, Mu,


load policy_bbench
HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];

irf_policy_bbench = [mu_e1, surph_e1, abar_e1*rhon_ss, wage_tot_difference_l ];

load policy_bb
HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];

irf_policy_bb = [mu_e1, surph_e1, abar_e1*rhon_ss, wage_tot_difference_l ];

load policy_aa
HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];

irf_policy_aa = [mu_e1, surph_e1, abar_e1*rhon_ss, wage_tot_difference_l ];


newpp=[0.25 , 0.25 , 8, 8];
      grid on
set(gcf,'PaperOrientation','portrait')
set(gcf,'PaperPosition',newpp)

HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];
   
    subplot(2,2,4),plot(Time_axis,irf_policy_bbench(:,1),'k',...
       Time_axis,irf_policy_aa(:,1),'--k.',Time_axis,irf_policy_bb(:,1),'-.k',Time_axis,zzero(1,:),':')
   
xlim([1 HORIZON]);
    grid on
	title('Retail markup')
 %   set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',{'1', '2', '3', '4', '5'})
set(findobj('Type','line'),'LineWidth',1)

subplot(2,2,1),plot(Time_axis,irf_policy_bbench(:,2),'k',...
       Time_axis,irf_policy_aa(:,2),'--k.',Time_axis,irf_policy_bb(:,2),'-.k',Time_axis,zzero(1,:),':')
   
xlim([1 HORIZON]);
    grid on
	title('Surplus h-workers')
 %   set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',{'1', '2', '3', '4', '5'})
set(findobj('Type','line'),'LineWidth',1)

subplot(2,2,2),plot(Time_axis,irf_policy_bbench(:,3),'k',...
       Time_axis,irf_policy_aa(:,3),'--k.',Time_axis,irf_policy_bb(:,3),'-.k',Time_axis,zzero(1,:),':')
   
xlim([1 HORIZON]);
    grid on
	title('Cutoff productivity l-workers - log-change')
 %   set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',{'1', '2', '3', '4', '5'})
set(findobj('Type','line'),'LineWidth',1)

subplot(2,2,3),plot(Time_axis,irf_policy_bbench(:,4),'k',...
       Time_axis,irf_policy_aa(:,4),'--k.',Time_axis,irf_policy_bb(:,4),'-.k',Time_axis,zzero(1,:),':')
   
xlim([1 HORIZON]);
    grid on
	title('Surplus l-workers')
 %   set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',{'1', '2', '3', '4', '5'})
set(findobj('Type','line'),'LineWidth',1)
		legend(solid, dashed, dotted)

figure

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% FIG B_TEMP /   abar*abar_ss, Mu,


load policy_bbench
HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];

irf_policy_bbench = [mu_e1, surph_e1, abar_e1*rhon_ss, wage_tot_difference_l ];

load policy_bb
HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];

irf_policy_bb = [mu_e1, surph_e1, abar_e1*rhon_ss, wage_tot_difference_l ];

load policy_aa
HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];

irf_policy_aa = [mu_e1, surph_e1, abar_e1*rhon_ss, wage_tot_difference_l ];


newpp=[0.25 , 0.25 , 8, 8];
      grid on
set(gcf,'PaperOrientation','portrait')
set(gcf,'PaperPosition',newpp)

HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];
   
    subplot(2,1,1),plot(Time_axis,irf_policy_bbench(:,1),'k',...
       Time_axis,irf_policy_aa(:,1),'--k.',Time_axis,irf_policy_bb(:,1),'-.k',Time_axis,zzero(1,:),':')
   
xlim([1 HORIZON]);
    grid on
	title('Retail markup')
 %   set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',{'1', '2', '3', '4', '5'})
set(findobj('Type','line'),'LineWidth',1)


subplot(2,1,2),plot(Time_axis,irf_policy_bbench(:,3),'k',...
       Time_axis,irf_policy_aa(:,3),'--k.',Time_axis,irf_policy_bb(:,3),'-.k',Time_axis,zzero(1,:),':')
   
xlim([1 HORIZON]);
    grid on
	title('Cutoff productivity l-workers - log-change')
 %   set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',{'1', '2', '3', '4', '5'})
set(findobj('Type','line'),'LineWidth',1)

legend(solid, dashed, dotted)

figure





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% POLICY AA (BENCHMARK): Expansionary omegay*N,omegay=0.39 policy_aa  // SOLID
solid = ['Policy (2): Respond to unemployment'] 
% POLICY A0: STRICT IT, policy_a0 //DASHED
dashed = ['Policy (5): Price stability'] 
% POLICY B0: Expansionary omegay*rhon,omegay=-0.01 policy_b0 //DOTTED
dotted = ['Policy (6): Respond to layoff rate'] 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% FIGURE C_POLICY - Unempl rate, PP from ss (subtract ss), and UNEMP SHARE
%%% l-WORKERS
%%%%% COLOR AREA so areas sum

load policy_aa
HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];

share_nl = nl_e1*nl_ss./(n_e1*n_ss)*100;
share_nh = nh_e1*nh_ss./(n_e1*n_ss)*100;
share_scaled_ul = share_nl.*(u_e1*u_ss)/100
share_scaled_uh = share_nh.*(u_e1*u_ss)/100

irf_policy_aa = [unempl, share_scaled_ul];

u_diff = [];
u_d_cumul = [];
ineq_ratio = [];
symm_infl_cost = [];

ul_cumul = ones(1,10) ;
uh_cumul = ones(1,10);
y_cumul = ones(1,10);
Pi_cumul =  ones(1,10);
Pi_cumul(1)=nan;

for count = 1:size(xit_e1,1)
    ul_cumul(count) = sum(share_scaled_ul(1:count,1));
    uh_cumul(count) = sum(share_scaled_uh(1:count,1));
    y_cumul(count) = sum(y_e1(1:count,1));
    ineq_ratio(count) = ul_cumul(count)/uh_cumul(count);
end

display('initial level unemployment for sacrifice ratio')
u_initial = 5.9491
pause

u_diff = unempl(2:size(xit_e1,1)) - u_initial;
u_diff = [0; u_diff];
for count = 1:size(xit_e1,1)
    Pi_cumul(count) = sum(abs(Pi_e1(2:count,1)));
    u_d_cumul(count) = sum(u_diff(1:count,1));
end

u_d_cumul(1) = nan;
u_diff(1) = nan;
Pi_cumul(1)=nan;
symm_infl_cost_cumul = Pi_cumul./u_d_cumul;
symm_infl_cost = Pi_cumul'./u_diff;

display('policy aa') 
display('sac ratio // sac ratio CUMUL //  ineq ratio // cumul y // cumul ul_share // cumul uh_share')
policy_matrix = [-symm_infl_cost(8), -symm_infl_cost_cumul(8), ineq_ratio(8), y_cumul(8), ul_cumul(8), uh_cumul(8)]

pause



load policy_a0
HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];

share_nl = nl_e1*nl_ss./(n_e1*n_ss)*100;
share_nh = nh_e1*nh_ss./(n_e1*n_ss)*100;
share_scaled_ul = share_nl.*(u_e1*u_ss)/100;
share_scaled_uh = share_nh.*(u_e1*u_ss)/100;

irf_policy_a0 = [unempl, share_scaled_ul];

u_diff = [];
u_d_cumul = [];
ineq_ratio = [];
symm_infl_cost = [];

ul_cumul = ones(1,10) ;
uh_cumul = ones(1,10);
y_cumul = ones(1,10);
Pi_cumul =  ones(1,10);
Pi_cumul(1)=nan;

for count = 1:size(xit_e1,1)
    ul_cumul(count) = sum(share_scaled_ul(1:count,1));
    uh_cumul(count) = sum(share_scaled_uh(1:count,1));
    y_cumul(count) = sum(y_e1(1:count,1));
    ineq_ratio(count) = ul_cumul(count)/uh_cumul(count);
end

u_diff = unempl(2:size(xit_e1,1)) - u_initial;
u_diff = [0; u_diff];
for count = 1:size(xit_e1,1)
    Pi_cumul(count) = sum(abs(Pi_e1(2:count,1)));
    u_d_cumul(count) = sum(u_diff(1:count,1));
end

u_d_cumul(1) = nan;
u_diff(1) = nan;
Pi_cumul(1)=nan;
symm_infl_cost_cumul = Pi_cumul./u_d_cumul;
symm_infl_cost = Pi_cumul'./u_diff;

display('policy a0') 
display('sac ratio // sac ratio CUMUL //  ineq ratio // cumul y // cumul ul_share // cumul uh_share')
policy_matrix = [-symm_infl_cost(8), -symm_infl_cost_cumul(8), ineq_ratio(8), y_cumul(8), ul_cumul(8), uh_cumul(8)]

pause


load policy_b0
HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];

share_nl = nl_e1*nl_ss./(n_e1*n_ss)*100;
share_nh = nh_e1*nh_ss./(n_e1*n_ss)*100;
share_scaled_ul = share_nl.*(u_e1*u_ss)/100;
share_scaled_uh = share_nh.*(u_e1*u_ss)/100;

irf_policy_b0 = [unempl, share_scaled_ul];

u_diff = [];
u_d_cumul = [];
ineq_ratio = [];
symm_infl_cost = [];

ul_cumul = ones(1,10) ;
uh_cumul = ones(1,10);
y_cumul = ones(1,10);
Pi_cumul =  ones(1,10);
Pi_cumul(1)=nan;

for count = 1:size(xit_e1,1)
    ul_cumul(count) = sum(share_scaled_ul(1:count,1));
    uh_cumul(count) = sum(share_scaled_uh(1:count,1));
    y_cumul(count) = sum(y_e1(1:count,1));
    ineq_ratio(count) = ul_cumul(count)/uh_cumul(count);
end

u_diff = unempl(2:size(xit_e1,1)) - u_initial;
u_diff = [0; u_diff];
for count = 1:size(xit_e1,1)
    Pi_cumul(count) = sum(abs(Pi_e1(2:count,1)));
    u_d_cumul(count) = sum(u_diff(1:count,1));
end

u_d_cumul(1) = nan;
u_diff(1) = nan;
Pi_cumul(1)=nan;
symm_infl_cost_cumul = Pi_cumul./u_d_cumul;
symm_infl_cost = Pi_cumul'./u_diff;

display('policy b0') 
display('sac ratio // sac ratio CUMUL //  ineq ratio // cumul y // cumul ul_share // cumul uh_share')
policy_matrix = [-symm_infl_cost(8), -symm_infl_cost_cumul(8), ineq_ratio(8), y_cumul(8), ul_cumul(8), uh_cumul(8)]

pause

   newpp=[0.25 , 0.25 , 8, 8];
      grid on
set(gcf,'PaperOrientation','portrait')
set(gcf,'PaperPosition',newpp)

newpp=[0.25 , 0.25 , 8, 8];
      grid on
set(gcf,'PaperOrientation','portrait')
set(gcf,'PaperPosition',newpp)
%set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',{'1', '2', '3', '4', '5'})
%set(findobj('Type','line'),'LineWidth',2)

    subplot(1,2,1),plot(Time_axis,irf_policy_aa(:,1),'k',...
        Time_axis,irf_policy_a0(:,1),'--k.',Time_axis,irf_policy_b0(:,1),'-.k',Time_axis,zzero(1,:),':')
   
xlim([1 HORIZON]);
    grid on
		legend(solid, dashed, dotted)
 grid on
 title('Unemployment Rate - log-change ')
 
   subplot(1,2,2),plot(Time_axis,irf_policy_aa(:,2),'k',...
        Time_axis,irf_policy_a0(:,2),'--k.',Time_axis,irf_policy_b0(:,2),'-.k',Time_axis,zzero(1,:),':')
   
   
xlim([1 HORIZON]);
ylim([0 6]);
    grid on
		legend(solid, dashed, dotted)
 grid on
 title('Unemployment share - low efficiency workers')
 
 %   set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',{'1', '2', '3', '4', '5'})
set(findobj('Type','line'),'LineWidth',1)

figure
ss





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% LOAD  POLICY A, B, BENCH

prompt='"text for POLICY BENCHMARK" (Benchmark - dashed - policy_bench)  ';
ddashed = input(prompt,'s');
dashed = ['DASHED: policy: ',ddashed] 
prompt='"text for POLICY A" (solid - policy_a)    ';
 ssolid = input(prompt,'s');
 solid = ['SOLID: policy: ',ssolid] 
 prompt='"text for POLICY B" (dotted - policy_b)    ';
 ddotted = input(prompt,'s');
 dotted = ['DOTTED: policy: ',ddotted] 

 % Then ylabel(solid)
 
%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% Policy Figures GRAPH 1 6 PANESL

load policy_a

share_nl = nl_e1*nl_ss./(n_e1*n_ss)*100;
share_nh = nh_e1*nh_ss./(n_e1*n_ss)*100;
share_scaled_ul = share_nl.*(u_e1*u_ss)/100;
share_scaled_uh = share_nh.*(u_e1*u_ss)/100;

u_diff = [];
u_d_cumul = [];
ineq_ratio = [];
symm_infl_cost = [];

ul_cumul = ones(1,10) ;
uh_cumul = ones(1,10);
y_cumul = ones(1,10);
Pi_cumul =  ones(1,10);
Pi_cumul(1)=nan;

for count = 1:size(xit_e1,1)
    ul_cumul(count) = sum(share_scaled_ul(1:count,1));
    uh_cumul(count) = sum(share_scaled_uh(1:count,1));
    y_cumul(count) = sum(y_e1(1:count,1));
    ineq_ratio(count) = ul_cumul(count)/uh_cumul(count);
end


%u_diff1 = unempl(1:size(xit_e1,1)-1);
%u_diff2 = unempl(2:size(xit_e1,1));
%u_diff = u_diff2-u_diff1;

%for count = 1:size(xit_e1,1)-1
  %  Pi_cumul(count) = sum(abs(Pi_e1(2:count,1)));
 %   u_d_cumul(count) = sum(u_diff(1:count,1));
%end
%u_d_cumul = [nan,u_d_cumul]';
%Pi_cumul(1)=nan;
%symm_infl_cost = Pi_cumul'./u_d_cumul;

display('initial level unemployment for sacrifice ratio')
u_initial = 5.9491
pause

u_diff = unempl(2:size(xit_e1,1)) - u_initial;
u_diff = [0; u_diff];
for count = 1:size(xit_e1,1)
    Pi_cumul(count) = sum(abs(Pi_e1(2:count,1)));
    u_d_cumul(count) = sum(u_diff(1:count,1));
end

u_d_cumul(1) = nan;
u_diff(1) = nan;
Pi_cumul(1)=nan;
symm_infl_cost_cumul = Pi_cumul./u_d_cumul;
symm_infl_cost = Pi_cumul'./u_diff;


irf_policy_a = [ul_cumul', uh_cumul', unempl,Pi_e1, -symm_infl_cost, ineq_ratio'];


load policy_bench


share_nl = nl_e1*nl_ss./(n_e1*n_ss)*100;
share_nh = nh_e1*nh_ss./(n_e1*n_ss)*100;
share_scaled_ul = share_nl.*(u_e1*u_ss)/100;
share_scaled_uh = share_nh.*(u_e1*u_ss)/100;

u_diff = [];
u_d_cumul = [];
ineq_ratio = [];
symm_infl_cost = [];

ul_cumul = ones(1,10) ;
uh_cumul = ones(1,10);
y_cumul = ones(1,10);
Pi_cumul =  ones(1,10);
Pi_cumul(1)=nan;

for count = 1:size(xit_e1,1)
    ul_cumul(count) = sum(share_scaled_ul(1:count,1));
    uh_cumul(count) = sum(share_scaled_uh(1:count,1));
    y_cumul(count) = sum(y_e1(1:count,1));
    ineq_ratio(count) = ul_cumul(count)/uh_cumul(count);
end

display('initial level unemployment for sacrifice ratio')
u_initial = 5.9491


u_diff = unempl(2:size(xit_e1,1)) - u_initial;
u_diff = [0; u_diff];
for count = 1:size(xit_e1,1)
    Pi_cumul(count) = sum(abs(Pi_e1(2:count,1)));
    u_d_cumul(count) = sum(u_diff(1:count,1));
end

u_d_cumul(1) = nan;
u_diff(1) = nan;
Pi_cumul(1)=nan;
symm_infl_cost_cumul = Pi_cumul./u_d_cumul;
symm_infl_cost = Pi_cumul'./u_diff;

irf_policy_bench = [ul_cumul', uh_cumul', unempl,Pi_e1, -symm_infl_cost, ineq_ratio'];

load policy_b


share_nl = nl_e1*nl_ss./(n_e1*n_ss)*100;
share_nh = nh_e1*nh_ss./(n_e1*n_ss)*100;
share_scaled_ul = share_nl.*(u_e1*u_ss)/100;
share_scaled_uh = share_nh.*(u_e1*u_ss)/100;

u_diff = [];
u_d_cumul = [];
ineq_ratio = [];
symm_infl_cost = [];

ul_cumul = ones(1,10) ;
uh_cumul = ones(1,10);
y_cumul = ones(1,10);
Pi_cumul =  ones(1,10);
Pi_cumul(1)=nan;

for count = 1:size(xit_e1,1)
    ul_cumul(count) = sum(share_scaled_ul(1:count,1));
    uh_cumul(count) = sum(share_scaled_uh(1:count,1));
    y_cumul(count) = sum(y_e1(1:count,1));
    ineq_ratio(count) = ul_cumul(count)/uh_cumul(count);
end

display('initial level unemployment for sacrifice ratio')
u_initial = 5.9491

u_diff = unempl(2:size(xit_e1,1)) - u_initial;
u_diff = [0; u_diff];
for count = 1:size(xit_e1,1)
    Pi_cumul(count) = sum(abs(Pi_e1(2:count,1)));
    u_d_cumul(count) = sum(u_diff(1:count,1));
end

u_d_cumul(1) = nan;
u_diff(1) = nan;
Pi_cumul(1)=nan;
symm_infl_cost_cumul = Pi_cumul./u_d_cumul;
symm_infl_cost = Pi_cumul'./u_diff;

irf_policy_b = [ul_cumul', uh_cumul', unempl,Pi_e1, -symm_infl_cost, ineq_ratio'];

HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];

%MODEL SPECIFIC variables
variable=[1:1:6];

varname1 =   ['nominal interest rate                  34']; 
varname = repmat(varname1(1,:),8,1);
varname(1,:)=['Low-efficiency cumulative unempl share   '];
varname(4,:)=['Quarterly inflation                      '];
varname(2,:)=['High-efficiency cumulative unempl share  '];
varname(5,:)=['Symmetric sacrifice ratio infl/unempl    '];
varname(6,:)=['Inequality Ratio unempl low/high efficie.'];
varname(3,:)=['Unempl rate - log-change                 '];

for counter = 1:1;
for index = 1:size(variable,2);
   newpp=[0.25 , 0.25 , 8, 8];
      grid on
set(gcf,'PaperOrientation','portrait')
set(gcf,'PaperPosition',newpp)
%set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',{'1', '2', '3', '4', '5'})
%set(findobj('Type','line'),'LineWidth',2)

%if index ==1 | index==2 | index == 4 | index == 6
   
    subplot(3,2,index),plot(Time_axis,irf_policy_a(:, 1+1*(index-1)+(counter-1)),'k',...
        Time_axis,irf_policy_bench(:, 1+1*(index-1)+(counter-1)),'--k',...
    Time_axis,irf_policy_b(:, 1+1*(index-1)+(counter-1)),':k')
   
xlim([1 HORIZON]);
    grid on
	title(varname(variable(index),:))
 %   set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',{'1', '2', '3', '4', '5'})
set(findobj('Type','line'),'LineWidth',1)

		if index == 3
            if counter == 1
ylabel(dotted)
            elseif counter == 2
			%ylabel('technology shock')
            else
			%ylabel('policy shock')
            end
      end;
       if index == 5,
         xlabel(dashed);	%second rule
         ylim([0 4])
		elseif index ==6,
         xlabel(solid); %first rule
      else,
		end;	
       
end

figure
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% FIGURE 2bis - FIG B BIS Unempl rate, PP from ss (subtract ss)
%%%%% COLOR AREA so areas sum

load policy_bench
HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];

share_nl = nl_e1*nl_ss./(n_e1*n_ss)*100;
share_nh = nh_e1*nh_ss./(n_e1*n_ss)*100;
share_scaled_ul = share_nl.*(u_e1*u_ss)/100
share_scaled_uh = share_nh.*(u_e1*u_ss)/100

   newpp=[0.25 , 0.25 , 8, 8];
      grid on
set(gcf,'PaperOrientation','portrait')
set(gcf,'PaperPosition',newpp)

newpp=[0.25 , 0.25 , 8, 8];
      grid on
set(gcf,'PaperOrientation','portrait')
set(gcf,'PaperPosition',newpp)
%set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',{'1', '2', '3', '4', '5'})
%set(findobj('Type','line'),'LineWidth',2)

    subplot(1,2,1),plot(Time_axis,u_e1*u_ss,'k',...
        Time_axis,uh_e1*uh_ss,'--k.',Time_axis,ul_e1*ul_ss,'-.k',Time_axis,zzero(1,:),':')
   
xlim([1 HORIZON]);
    grid on
		legend('total',...
    'high efficiency workers', 'low efficiency workers')
 grid on
 title('Unemployment Rate - log-change ')

 ylabel(dashed)
 
    %subplot(1,2,2),plot(Time_axis,u_e1*u_ss,'k',...
    subplot(1,2,2),plot(Time_axis,share_scaled_ul,'k',...
        Time_axis,share_scaled_uh,'--k.', Time_axis,zzero(1,:),':')
   
xlim([1 HORIZON]);
    grid on
		legend('total',...
    'high efficiency workers')
 grid on
 title('Unemployment shares')
 
 %   set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',{'1', '2', '3', '4', '5'})
set(findobj('Type','line'),'LineWidth',1)

figure


%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%Figure 2bis - Second policy
%%%%%%%%%%%%%%%%%%%%%%%%%%

load policy_a
HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];

share_nl = nl_e1*nl_ss./(n_e1*n_ss)*100;
share_nh = nh_e1*nh_ss./(n_e1*n_ss)*100;
share_scaled_ul = share_nl.*(u_e1*u_ss)/100
share_scaled_uh = share_nh.*(u_e1*u_ss)/100
%share_scaled_ul = share_nl.*(unempl-u_ss*100)/100
%share_scaled_uh = share_nh.*(unempl-u_ss*100)/100

   newpp=[0.25 , 0.25 , 8, 8];
      grid on
set(gcf,'PaperOrientation','portrait')
set(gcf,'PaperPosition',newpp)

newpp=[0.25 , 0.25 , 8, 8];
      grid on
set(gcf,'PaperOrientation','portrait')
set(gcf,'PaperPosition',newpp)
%set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',{'1', '2', '3', '4', '5'})
%set(findobj('Type','line'),'LineWidth',2)

    subplot(1,2,1),plot(Time_axis,u_e1*u_ss,'k',...
        Time_axis,uh_e1*uh_ss,'--k.',Time_axis,ul_e1*ul_ss,'-.k',Time_axis,zzero(1,:),':')
   
xlim([1 HORIZON]);
    grid on
		legend('total',...
    'high efficiency workers', 'low efficiency workers')
 grid on
 title('Unemployment Rate - log-change ')

 ylabel(solid)
 
    %subplot(1,2,2),plot(Time_axis,u_e1*u_ss,'k',...
    subplot(1,2,2),plot(Time_axis,share_scaled_ul,'k',...
        Time_axis,share_scaled_uh,'--k.', Time_axis,zzero(1,:),':')
   
xlim([1 HORIZON]);
    grid on
		legend('total',...
    'high efficiency workers')
 grid on
 title('Unemployment shares')
 
 %   set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',{'1', '2', '3', '4', '5'})
set(findobj('Type','line'),'LineWidth',1)

figure



%%%%%%%%%%%%%%% POLICY FIGURE - WAGES
%TOTAL WAGES (not hourly)
load policy_a

irf_policy_a = [wage_tot_difference, wage_tot_difference_l, wage_tot_difference_h];

load policy_b

irf_policy_b = [wage_tot_difference, wage_tot_difference_l, wage_tot_difference_h];

load policy_bench

irf_policy_bench = [wage_tot_difference, wage_tot_difference_l, wage_tot_difference_h];

   newpp=[0.25 , 0.25 , 8, 8];
      grid on
set(gcf,'PaperOrientation','portrait')
set(gcf,'PaperPosition',newpp)

HORIZON = size(xit_e1,1);
zzero=zeros(1,HORIZON);
Time_axis = [1:HORIZON];

%MODEL SPECIFIC variables
variable=[1:1:3];
 
varname1 =   ['               nominal interest rate                  34']; 
varname = repmat(varname1(1,:),8,1);
varname(1,:)=['Average total earnings                                  '];
varname(2,:)=['Average total earnings - low-efficiency                 '];
varname(3,:)=['Average total earnings -  high-efficiency               '];

for counter = 1:1;
for index = 1:size(variable,2);
   newpp=[0.25 , 0.25 , 8, 8];
      grid on
set(gcf,'PaperOrientation','portrait')
set(gcf,'PaperPosition',newpp)
%set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',[1  2 3 4 5])
%set(findobj('Type','line'),'LineWidth',2)

%if index ==1 | index==2 | index == 4 | index == 6
   
    subplot(3,1,index),plot(Time_axis,irf_policy_a(:, 1+1*(index-1)+(counter-1)),'k',...
        Time_axis,irf_policy_b(:, 1+1*(index-1)+(counter-1)),':k',...
        Time_axis,zzero(1,:),':',Time_axis,irf_policy_bench(:, 1+1*(index-1)+(counter-1)),'--k')
   
xlim([1 HORIZON]);
    grid on
	title(varname(variable(index),:))
    %set(gca,'XTick',[ 4 8 12 16 20])
%set(gca,'XTickLabel',[1  2 3 4 5])
set(findobj('Type','line'),'LineWidth',1)

		if index == 2
            if counter == 1
%ylabel('COVID - Temp Layoffs')
ylabel(solid)
            elseif counter == 2
			%ylabel('technology shock')
            else
			%ylabel('policy shock')
            end
      end;
       if index == 3,
          %xlabel(['DASHED: Permanent layoffs model       SOLID: Temporary layoffs model']);	%second rule
          xlabel(dashed)
		elseif index ==4,
         xlabel(['']); %first rule
       
       else,
		end;	
       
end
figure
end
ddddddddddddd
